## volk 1.2.1

=== CMakeLists.txt ===
#
# Copyright 2011 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.6)
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type: None Debug Release RelWithDebInfo MinSizeRel")
project(volk)
enable_language(CXX)
enable_language(C)
enable_testing()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")

set(CMAKE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}) #allows this to be a sub-project
set(CMAKE_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}) #allows this to be a sub-project
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules) #location for custom "Modules"

include(VolkBuildTypes)
#select the release build type by default to get optimization flags
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS "Build type not specified: defaulting to release.")
endif()
VOLK_CHECK_BUILD_TYPE(${CMAKE_BUILD_TYPE})
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "")
message(STATUS "Build type set to ${CMAKE_BUILD_TYPE}.")

set(VERSION_INFO_MAJOR_VERSION 1)
set(VERSION_INFO_MINOR_VERSION 2)
set(VERSION_INFO_MAINT_VERSION 1)
include(VolkVersion) #setup version info


########################################################################
# Environment setup
########################################################################
IF(NOT DEFINED BOOST_ROOT)
    SET(BOOST_ROOT ${CMAKE_INSTALL_PREFIX})
ENDIF()

IF(NOT DEFINED CROSSCOMPILE_MULTILIB)
    SET(CROSSCOMPILE_MULTILIB "")
ENDIF()
SET(CROSSCOMPILE_MULTILIB ${CROSSCOMPILE_MULTILIB} CACHE STRING "Define \"true\" if you have and want to use multiple C development libs installed for cross compile")


########################################################################
# Dependencies setup
########################################################################

# Python
include(VolkPython) #sets PYTHON_EXECUTABLE and PYTHON_DASH_B
VOLK_PYTHON_CHECK_MODULE("python >= 2.5" sys "sys.version.split()[0] >= '2.5'" PYTHON_MIN_VER_FOUND)
VOLK_PYTHON_CHECK_MODULE("Cheetah >= 2.0.0" Cheetah "Cheetah.Version >= '2.0.0'" CHEETAH_FOUND)

if(NOT PYTHON_MIN_VER_FOUND)
    message(FATAL_ERROR "Python 2.5 or greater required to build VOLK")
endif()

# Cheetah
if(NOT CHEETAH_FOUND)
    message(FATAL_ERROR "Cheetah templates required to build VOLK")
endif()

# Boost
if(MSVC)
    if (NOT DEFINED BOOST_ALL_DYN_LINK)
        set(BOOST_ALL_DYN_LINK TRUE)
    endif()
    set(BOOST_ALL_DYN_LINK "${BOOST_ALL_DYN_LINK}" CACHE BOOL "boost enable dynamic linking")
    if(BOOST_ALL_DYN_LINK)
        add_definitions(-DBOOST_ALL_DYN_LINK) #setup boost auto-linking in msvc
    else(BOOST_ALL_DYN_LINK)
        unset(BOOST_REQUIRED_COMPONENTS) #empty components list for static link
    endif(BOOST_ALL_DYN_LINK)
endif(MSVC)

include(VolkBoost)

if(NOT Boost_FOUND)
    message(FATAL_ERROR "VOLK Requires boost to build")
endif()

# Orc
option(ENABLE_ORC "Enable Orc" True)
if(ENABLE_ORC)
  find_package(ORC)
else(ENABLE_ORC)
  message(STATUS "Disabling use of ORC")
endif(ENABLE_ORC)

########################################################################
# Setup doxygen
########################################################################
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(
        ${CMAKE_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_BINARY_DIR}/Doxyfile
    @ONLY)

    add_custom_target(doc
        ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Generating documentation with Doxygen" VERBATIM
    )
endif(DOXYGEN_FOUND)

########################################################################
# Setup the package config file
########################################################################
#set variables found in the pc.in file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib${LIB_SUFFIX}")
set(includedir "\${prefix}/include")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/volk.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/volk.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/volk.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig
    COMPONENT "volk_devel"
)

########################################################################
# Install all headers in the include directories
########################################################################
set(VOLK_RUNTIME_DIR   bin)
set(VOLK_LIBRARY_DIR   lib${LIB_SUFFIX})
set(VOLK_INCLUDE_DIR   include)

install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/kernels/volk
    DESTINATION include COMPONENT "volk_devel"
    FILES_MATCHING PATTERN "*.h"
)

install(FILES
    ${CMAKE_SOURCE_DIR}/include/volk/volk_prefs.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_complex.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_common.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_avx_intrinsics.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_sse3_intrinsics.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_neon_intrinsics.h
    ${CMAKE_BINARY_DIR}/include/volk/volk.h
    ${CMAKE_BINARY_DIR}/include/volk/volk_cpu.h
    ${CMAKE_BINARY_DIR}/include/volk/volk_config_fixed.h
    ${CMAKE_BINARY_DIR}/include/volk/volk_typedefs.h
    ${CMAKE_SOURCE_DIR}/include/volk/volk_malloc.h
    DESTINATION include/volk
    COMPONENT "volk_devel"
)

########################################################################
# On Apple only, set install name and use rpath correctly, if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR
            ${CMAKE_INSTALL_PREFIX}/${VOLK_LIBRARY_DIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH
            ${CMAKE_INSTALL_PREFIX}/${VOLK_LIBRARY_DIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)

########################################################################
# Create uninstall target
########################################################################
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
@ONLY)

# Only add the target if there isn't one defined already
if(NOT TARGET uninstall)
    add_custom_target(uninstall
        ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
    )
endif()


########################################################################
# Install our Cmake modules into $prefix/lib/cmake/volk
# See "Package Configuration Files" on page:
#    http://www.cmake.org/Wiki/CMake/Tutorials/Packaging
########################################################################

configure_file(
  ${CMAKE_SOURCE_DIR}/cmake/Modules/VolkConfigVersion.cmake.in
  ${CMAKE_BINARY_DIR}/cmake/Modules/VolkConfigVersion.cmake
@ONLY)


########################################################################
# Install cmake search routine for external use
########################################################################

if(NOT CMAKE_MODULES_DIR)
    set(CMAKE_MODULES_DIR lib${LIB_SUFFIX}/cmake)
endif(NOT CMAKE_MODULES_DIR)

install(
    FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/VolkConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/Modules/VolkConfigVersion.cmake
    DESTINATION ${CMAKE_MODULES_DIR}/volk
    COMPONENT "volk_devel"
)

########################################################################
# Option to enable QA testing, on by default
########################################################################
OPTION(ENABLE_TESTING "Enable QA testing" ON)
if(ENABLE_TESTING)
  message(STATUS "QA Testing is enabled.")
else()
  message(STATUS "QA Testing is disabled.")
endif()
message(STATUS "  Modify using: -DENABLE_TESTING=ON/OFF")

########################################################################
# Setup the library
########################################################################
add_subdirectory(lib)

########################################################################
# And the utility apps
########################################################################
add_subdirectory(apps)
add_subdirectory(python/volk_modtool)

########################################################################
# Print summary
########################################################################
message(STATUS "Using install prefix: ${CMAKE_INSTALL_PREFIX}")

=== apps/CMakeLists.txt ===
#
# Copyright 2011-2013 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

########################################################################
# Setup profiler
########################################################################
if(MSVC)
    include_directories(${CMAKE_SOURCE_DIR}/cmake/msvc)
endif(MSVC)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib
    ${CMAKE_BINARY_DIR}/lib
    ${Boost_INCLUDE_DIRS}
)

# MAKE volk_profile
add_executable(volk_profile
    ${CMAKE_CURRENT_SOURCE_DIR}/volk_profile.cc
    ${CMAKE_SOURCE_DIR}/lib/qa_utils.cc
)


if(ENABLE_STATIC_LIBS)
    target_link_libraries(volk_profile volk_static ${Boost_LIBRARIES})
    set_target_properties(volk_profile PROPERTIES LINK_FLAGS "-static")
else()
    target_link_libraries(volk_profile volk ${Boost_LIBRARIES})
endif()

install(
    TARGETS volk_profile
    DESTINATION bin
    COMPONENT "volk"
)

# MAKE volk-config-info
add_executable(volk-config-info volk-config-info.cc)

if(ENABLE_STATIC_LIBS)
    target_link_libraries(volk-config-info volk_static ${Boost_LIBRARIES})
    set_target_properties(volk-config-info PROPERTIES LINK_FLAGS "-static")
else()
    target_link_libraries(volk-config-info volk ${Boost_LIBRARIES})
endif()

install(
    TARGETS volk-config-info
    DESTINATION bin
    COMPONENT "volk"
)

=== lib/CMakeLists.txt ===
#
# Copyright 2011-2012,2014 Free Software Foundation, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

########################################################################
# header file detection
########################################################################
include(CheckIncludeFile)
CHECK_INCLUDE_FILE(cpuid.h HAVE_CPUID_H)
if(HAVE_CPUID_H)
    add_definitions(-DHAVE_CPUID_H)
endif()

CHECK_INCLUDE_FILE(intrin.h HAVE_INTRIN_H)
if(HAVE_INTRIN_H)
    add_definitions(-DHAVE_INTRIN_H)
endif()

CHECK_INCLUDE_FILE(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
    add_definitions(-DHAVE_FENV_H)
endif()

CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)
if(HAVE_DLFCN_H)
    add_definitions(-DHAVE_DLFCN_H)
    list(APPEND volk_libraries ${CMAKE_DL_LIBS})
endif()

########################################################################
# Setup the compiler name
########################################################################
set(COMPILER_NAME ${CMAKE_C_COMPILER_ID})
if(MSVC) #its not set otherwise
    set(COMPILER_NAME MSVC)
endif()

message(STATUS "Compiler name: ${COMPILER_NAME}")

if(NOT DEFINED COMPILER_NAME)
    message(FATAL_ERROR "COMPILER_NAME undefined. Volk build may not support this compiler.")
endif()

########################################################################
# Special clang flag so flag checks can fail
########################################################################
if(COMPILER_NAME MATCHES "GNU")
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-Werror=unused-command-line-argument" HAVE_WERROR_UNUSED_CMD_LINE_ARG)
    if(HAVE_WERROR_UNUSED_CMD_LINE_ARG)
        set(VOLK_FLAG_CHECK_FLAGS "-Werror=unused-command-line-argument")
    endif()
endif()

########################################################################
# check for posix_memalign, since some OSs do not internally define
# _XOPEN_SOURCE or _POSIX_C_SOURCE; they leave this to the user.
########################################################################

include(CheckFunctionExists)
CHECK_FUNCTION_EXISTS(posix_memalign HAVE_POSIX_MEMALIGN)

if(HAVE_POSIX_MEMALIGN)
      add_definitions(-DHAVE_POSIX_MEMALIGN)
endif(HAVE_POSIX_MEMALIGN)

########################################################################
# detect x86 flavor of CPU
########################################################################
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "^(i.86|x86|x86_64|amd64|AMD64)$")
    message(STATUS "x86* CPU detected")
    set(CPU_IS_x86 TRUE)
endif()

########################################################################
# determine passing architectures based on compile flag tests
########################################################################
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
    ${CMAKE_SOURCE_DIR}/gen/volk_compile_utils.py
    --mode "arch_flags" --compiler "${COMPILER_NAME}"
    OUTPUT_VARIABLE arch_flag_lines OUTPUT_STRIP_TRAILING_WHITESPACE
)

macro(check_arch arch_name)
    set(flags ${ARGN})
    set(have_${arch_name} TRUE)
    foreach(flag ${flags})
        if ( (${COMPILER_NAME} STREQUAL "MSVC") AND (${flag} STREQUAL "/arch:SSE2" OR ${flag} STREQUAL "/arch:SSE" ))
            # SSE/SSE2 is supported in MSVC since VS 2005 but flag not available when compiling 64-bit so do not check
        else()
            include(CheckCXXCompilerFlag)
            set(have_flag have${flag})
            #make the have_flag have nice alphanum chars (just for looks/not necessary)
            execute_process(
                COMMAND ${PYTHON_EXECUTABLE} -c "import re; print(re.sub('\\W', '_', '${have_flag}'))"
                OUTPUT_VARIABLE have_flag OUTPUT_STRIP_TRAILING_WHITESPACE
            )
            if(VOLK_FLAG_CHECK_FLAGS)
                set(CMAKE_REQUIRED_FLAGS ${VOLK_FLAG_CHECK_FLAGS})
            endif()
            CHECK_CXX_COMPILER_FLAG(${flag} ${have_flag})
            unset(CMAKE_REQUIRED_FLAGS)
            if (NOT ${have_flag})
                set(have_${arch_name} FALSE)
            endif()
        endif()
    endforeach()
    if (have_${arch_name})
        list(APPEND available_archs ${arch_name})
    endif()
endmacro(check_arch)

foreach(line ${arch_flag_lines})
    string(REGEX REPLACE "," ";" arch_flags ${line})
    check_arch(${arch_flags})
endforeach(line)

macro(OVERRULE_ARCH arch reason)
    message(STATUS "${reason}, Overruled arch ${arch}")
    list(REMOVE_ITEM available_archs ${arch})
endmacro(OVERRULE_ARCH)

########################################################################
# eliminate AVX on if not on x86, or if the compiler does not accept
# the xgetbv instruction, or {if not cross-compiling and the xgetbv
# executable does not function correctly}.
########################################################################
set(HAVE_XGETBV 0)
set(HAVE_AVX_CVTPI32_PS 0)
if(CPU_IS_x86)
    # check to see if the compiler/linker works with xgetb instruction
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv.c "unsigned long long _xgetbv(unsigned int index) { unsigned int eax, edx; __asm__ __volatile__(\"xgetbv\" : \"=a\"(eax), \"=d\"(edx) : \"c\"(index)); return ((unsigned long long)edx << 32) | eax; } int main (void) { (void) _xgetbv(0); return (0); }")
    execute_process(COMMAND ${CMAKE_C_COMPILER} -o
        ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv
        ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv.c
        OUTPUT_QUIET ERROR_QUIET
        RESULT_VARIABLE avx_compile_result)
    if(NOT ${avx_compile_result} EQUAL 0)
        OVERRULE_ARCH(avx "Compiler or linker missing xgetbv instruction")
    elseif(NOT CROSSCOMPILE_MULTILIB)
        execute_process(COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv
            OUTPUT_QUIET ERROR_QUIET
            RESULT_VARIABLE avx_exe_result)
        if(NOT ${avx_exe_result} EQUAL 0)
            OVERRULE_ARCH(avx "CPU missing xgetbv")
        else()
            set(HAVE_XGETBV 1)
        endif()
    else()
        # cross compiling and compiler/linker seems to work; assume working
        set(HAVE_XGETBV 1)
    endif()
    file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv
        ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv.c)

    #########################################################################
    # eliminate AVX if cvtpi32_ps intrinsic fails like some versions of clang
    #########################################################################

    # check to see if the compiler/linker works with cvtpi32_ps instrinsic when using AVX
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c "#include <immintrin.h>\nint main (void) {__m128 __a; __m64 __b; __m128 foo = _mm_cvtpi32_ps(__a, __b); return (0); }")
    execute_process(COMMAND ${CMAKE_C_COMPILER} -mavx -o
      ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
      ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c
      OUTPUT_QUIET ERROR_QUIET
      RESULT_VARIABLE avx_compile_result)
    if(NOT ${avx_compile_result} EQUAL 0)
      OVERRULE_ARCH(avx "Compiler missing cvtpi32_ps instrinsic")
    elseif(NOT CROSSCOMPILE_MULTILIB)
      execute_process(COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
        OUTPUT_QUIET ERROR_QUIET
        RESULT_VARIABLE avx_exe_result)
      if(NOT ${avx_exe_result} EQUAL 0)
        OVERRULE_ARCH(avx "CPU missing cvtpi32_ps")
      else()
        set(HAVE_AVX_CVTPI32_PS 1)
      endif()
    else()
      set(HAVE_AVX_CVTPI32_PS 1)
    endif()
    file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
      ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps.c)

    # Disable SSE4a if Clang is less than version 3.2
    if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
      # Figure out the version of Clang
      if(CMAKE_VERSION VERSION_LESS "2.8.10")
        # Exctract the Clang version from the --version string.
        # In cmake 2.8.10, we can just use CMAKE_C_COMPILER_VERSION
        # without having to go through these string manipulations
        execute_process(COMMAND ${CMAKE_C_COMPILER} --version
          OUTPUT_VARIABLE clang_version)
        string(REGEX MATCH "[0-9].[0-9]" CMAKE_C_COMPILER_VERSION ${clang_version})
      endif(CMAKE_VERSION VERSION_LESS "2.8.10")

      if(CMAKE_C_COMPILER_VERSION VERSION_LESS "3.2")
        OVERRULE_ARCH(sse4_a "Clang >= 3.2 required for SSE4a")
      endif(CMAKE_C_COMPILER_VERSION VERSION_LESS "3.2")
    endif("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")

endif(CPU_IS_x86)

if(${HAVE_XGETBV})
    add_definitions(-DHAVE_XGETBV)
endif()

if(${HAVE_AVX_CVTPI32_PS})
    add_definitions(-DHAVE_AVX_CVTPI32_PS)
endif()

########################################################################
# if the CPU is not x86, eliminate all Intel SIMD
########################################################################

if(NOT CPU_IS_x86)
    OVERRULE_ARCH(3dnow "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(mmx "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse2 "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse3 "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(ssse3 "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse4_a "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse4_1 "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(sse4_2 "Architecture is not x86 or x86_64")
    OVERRULE_ARCH(avx "Architecture is not x86 or x86_64")
endif(NOT CPU_IS_x86)

########################################################################
# implement overruling in the ORC case,
# since ORC always passes flag detection
########################################################################
if(NOT ORC_FOUND)
    OVERRULE_ARCH(orc "ORC support not found")
endif()

########################################################################
# implement overruling in the non-multilib case
# this makes things work when both -m32 and -m64 pass
########################################################################
if(NOT CROSSCOMPILE_MULTILIB AND CPU_IS_x86)
    include(CheckTypeSize)
    check_type_size("void*[8]" SIZEOF_CPU BUILTIN_TYPES_ONLY)
    if (${SIZEOF_CPU} EQUAL 64)
        OVERRULE_ARCH(32 "CPU width is 64 bits")
    endif()
    if (${SIZEOF_CPU} EQUAL 32)
        OVERRULE_ARCH(64 "CPU width is 32 bits")
    endif()

    #MSVC 64 bit does not have MMX, overrule it
    if (${SIZEOF_CPU} EQUAL 64 AND MSVC)
        OVERRULE_ARCH(mmx "No MMX for Win64")
    endif()

endif()

########################################################################
# done overrules! print the result
########################################################################
message(STATUS "Available architectures: ${available_archs}")

########################################################################
# determine available machines given the available architectures
########################################################################
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} ${PYTHON_DASH_B}
    ${CMAKE_SOURCE_DIR}/gen/volk_compile_utils.py
    --mode "machines" --archs "${available_archs}"
    OUTPUT_VARIABLE available_machines OUTPUT_STRIP_TRAILING_WHITESPACE
)

########################################################################
# Implement machine overruling for redundant machines:
# A machine is redundant when expansion rules occur,
# and the arch superset passes configuration checks.
# When this occurs, eliminate the redundant machines

## volk 1.1

=== debian/changelog ===
volk (1.1-3) unstable; urgency=low

  * drop dh_acc to get reproducible builds

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 11 Sep 2015 22:57:06 -0400

volk (1.1-2) unstable; urgency=low

  * use dh-acc

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 07 Sep 2015 15:45:20 -0400

volk (1.1-1) unstable; urgency=medium

  * re-organize package naming convention
  * New upstream release tag v1.1
  New architectures exist for the AVX2 and FMA ISAs. Along
  with the build-system support the following kernels have
  no proto-kernels taking advantage of these architectures:
  
  * 32f_x2_dot_prod_32f
  * 32fc_x2_multiply_32fc
  * 64_byteswap
  * 32f_binary_slicer_8i
  * 16u_byteswap
  * 32u_byteswap
  
  QA/profiler
  -----------
  
  The profiler now generates buffers that are vlen + a tiny
  amount and generates random data to fill buffers. This is
  intended to catch bugs in protokernels that write beyond
  num_points.

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 26 Aug 2015 09:22:48 -0400

volk (1.0.2-2) unstable; urgency=low

  * Use SOURCE_DATE_EPOCH from the environment, if defined,
    rather than current date and time to implement volk_build_date()
    (embedding build date in a library does not help reproducible builds)
  * add watch file

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Aug 2015 17:43:15 -0400

volk (1.0.2-1) unstable; urgency=medium

  * Maintenance release 24 Jul 2015 by Nathan West
  * The major change is the CMake logic to add ASM protokernels. Rather
    than depending on CFLAGS and ASMFLAGS we use the results of VOLK's
    built in has_ARCH tests. All configurations should work the same as
    before, but manually specifying CFLAGS and ASMFLAGS on the cmake call
    for ARM native builds should no longer be necessary.
  * The 32fc_s32fc_x2_rotator_32fc generic protokernel now includes a
    previously implied header.
  * Finally, there is a fix to return the "best" protokernel to the
    dispatcher when no volk_config exists. Thanks to Alexandre Raymond for
    pointing this out.
  * with maint branch patch:
      kernels-add-missing-include-arm_neon.h
  * removed unused build-dependency on liboil0.3-dev (closes: #793626)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 05 Aug 2015 00:43:40 -0400

volk (1.0.1-1) unstable; urgency=low

  * Maintenance Release v1.0.1 08 Jul 2015 by Nathan West
    This is a maintenance release with bug fixes since the initial release of
    v1.0 in April.
    
  * Contributors
   
    The following authors have contributed code to this release:
    
    Doug Geiger doug.geiger@bioradiation.net
    Elliot Briggs elliot.briggs@gmail.com
    Marcus Mueller marcus@hostalia.de
    Nathan West nathan.west@okstate.edu
    Tom Rondeau tom@trondeau.com
   
  * Kernels
   
    Several bug fixes in different kernels. The NEON implementations of the
    following kernels have been fixed:
   
      32f_x2_add_32f
      32f_x2_dot_prod_32f
      32fc_s32fc_multiply_32fc
      32fc_x2_multiply_32fc
   
   Additionally the NEON asm based 32f_x2_add_32f protokernels were not being
   used and are now included and available for use via the dispatcher.
   
   The 32f_s32f_x2_fm_detect_32f kernel now has a puppet. This solves QA seg
   faults on 32-bit machines and provide a better test for this kernel.
   
   The 32fc_s32fc_x2_rotator_32fc generic protokernel replaced cabsf with
   hypotf for better Android support.

  * Building
   
    Static builds now trigger the applications (volk_profile and
    volk-config-info) to be statically linked.
    
    The file gcc_x86_cpuid.h has been removed since it was no longer being
    used. Previously it provided cpuid functionality for ancient compilers
    that we do not support.
    
    All build types now use -Wall.

  * QA and Testing
   
   The documentation around the --update option to volk_profile now makes it
   clear that the option will only profile kernels without entries in
   volk_profile. The signature of run_volk_tests with expanded args changed
   signed types to unsigned types to reflect the actual input.
   
   The remaining changes are all non-functional changes to address issues
   from Coverity.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 10 Jul 2015 17:57:42 -0400

volk (1.0-5) unstable; urgency=medium

  * native-armv7-build-support skips neon on Debian armel (Closes: #789972)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 04 Jul 2015 12:36:36 -0400

volk (1.0-4) unstable; urgency=low

  * update native-armv7-build-support patch from gnuradio volk package

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 25 Jun 2015 16:38:49 -0400

volk (1.0-3) unstable; urgency=medium

  * Add Breaks/Replaces (Closes: #789893, #789894)
  * Allow failing tests

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 25 Jun 2015 12:46:06 -0400

volk (1.0-2) unstable; urgency=medium

  * kernels-add-missing-math.h-include-to-rotator

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 24 Jun 2015 21:09:32 -0400

volk (1.0-1) unstable; urgency=low

  * Initial package (Closes: #782417)
  Initial Release 11 Apr 2015 by Nathan West
  
  VOLK 1.0 is available. This is the first release of VOLK as an independently
  tracked sub-project of GNU Radio.

  * Contributors
  
  VOLK has been tracked separately from GNU Radio since 2014 Dec 23.
  Contributors between the split and the initial release are

  Albert Holguin aholguin_77@yahoo.com
  Doug Geiger doug.geiger@bioradiation.net
  Elliot Briggs elliot.briggs@gmail.com
  Julien Olivain julien.olivain@lsv.ens-cachan.fr
  Michael Dickens michael.dickens@ettus.com
  Nathan West nathan.west@okstate.edu
  Tom Rondeau tom@trondeau.com
  
  * QA
  
  The test and profiler have significantly changed. The profiler supports
  run-time changes to vlen and iters to help kernel development and provide
  more flexibility on embedded systems. Additionally there is a new option


=== debian/control ===
Source: volk
Section: libdevel
Priority: extra
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.0.0~),
               dh-python,
               doxygen,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-test-dev,
               liborc-0.4-dev,
               pkg-config,
               python,
               python-cheetah
Standards-Version: 3.9.6
Homepage: http://libvolk.org
Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-volk.git
Vcs-Browser: http://anonscm.debian.org/cgit/users/bottoms/pkg-volk.git/

Package: libvolk1.1
Section: libs
Architecture: any
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Recommends: libvolk1-bin
Suggests: libvolk1-dev
Description: vector optimized functions
 Vector-Optimized Library of Kernels is designed to help
 applications work with the processor's SIMD instruction sets. These are
 very powerful vector operations that can give signal processing a
 huge boost in performance.

Package: libvolk1-dev
Section: libdevel
Architecture: any
Pre-Depends: multiarch-support
Depends: libvolk1.1 (=${binary:Version}), ${misc:Depends}
Breaks: gnuradio-dev (<<3.7), libvolk-dev, libvolk1.0-dev
Replaces: libvolk-dev, libvolk1.0-dev
Description: vector optimized function headers
 Vector-Optimized Library of Kernels is designed to help
 applications work with the processor's SIMD instruction sets. These are
 very powerful vector operations that can give signal processing a
 huge boost in performance.
 .
 This package contains the header files.
 For documentation, see libvolk-doc.

Package: libvolk1-bin
Section: libs
Architecture: any
Pre-Depends: multiarch-support
Depends: libvolk1.1 (=${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Breaks: libvolk-bin, libvolk1.0-bin
Replaces: libvolk-bin, libvolk1.0-bin
Description: vector optimized runtime tools
 Vector-Optimized Library of Kernels is designed to help
 applications work with the processor's SIMD instruction sets. These are
 very powerful vector operations that can give signal processing a
 huge boost in performance.
 .
 This package includes the volk_profile tool.

## volk 1.2.1

=== debian/changelog ===
volk (1.2.1-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 07 Feb 2016 19:38:32 -0500

volk (1.2-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 24 Dec 2015 20:28:13 -0500

volk (1.1.1-5) experimental; urgency=medium

  * update to v1.1.1-22-gef53547 to support gnuradio 3.7.9

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 11 Dec 2015 13:12:55 -0500

volk (1.1.1-4) unstable; urgency=medium

  * more lintian fixes

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 25 Nov 2015 21:49:58 -0500

volk (1.1.1-3) unstable; urgency=medium

  * Lintian fixes Pre-Depends

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 19 Nov 2015 21:24:27 -0500

volk (1.1.1-2) unstable; urgency=medium

  * Note that libvolk1-dev replaces files in gnuradio-dev versions <<3.7.8
    (Closes: #802646) again. Thanks Andreas Beckmann.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 13 Nov 2015 18:45:49 -0500

volk (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * New architectures exist for the AVX2 and FMA ISAs.
  * The profiler now generates buffers that are vlen + a tiny amount and
    generates random data to fill buffers. This is intended to catch bugs
    in protokernels that write beyond num_points.
  * Note that libvolk1-dev replaces files in earlier gnuradio-dev versions
    (Closes: #802646)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 01 Nov 2015 18:45:43 -0500

volk (1.1-4) unstable; urgency=medium

  * update to v1.1-12-g264addc

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 29 Sep 2015 23:41:50 -0400

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 Package: libvolk1.1
 Section: libs
 Architecture: any
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Recommends: libvolk1-bin
@@ -34,12 +34,11 @@
  huge boost in performance.
 
 Package: libvolk1-dev
-Section: libdevel
 Architecture: any
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libvolk1.1 (=${binary:Version}), ${misc:Depends}
-Breaks: gnuradio-dev (<<3.7), libvolk-dev, libvolk1.0-dev
-Replaces: libvolk-dev, libvolk1.0-dev
+Breaks: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev
+Replaces: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev
 Description: vector optimized function headers
  Vector-Optimized Library of Kernels is designed to help
  applications work with the processor's SIMD instruction sets. These are
@@ -52,7 +51,7 @@
 Package: libvolk1-bin
 Section: libs
 Architecture: any
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libvolk1.1 (=${binary:Version}),
          ${misc:Depends},
          ${python:Depends},

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
DH_VERBOSE=1
export DH_VERBOSE

%:
	dh $@ --with python2

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DPYTHON_EXECUTABLE=/usr/bin/python

override_dh_auto_test:
	- dh_auto_test -- CTEST_TEST_TIMEOUT=60

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/volk-$1.tar.gz/ \
  https://github.com/gnuradio/volk/tags .*/v?(\d\S*)\.tar\.gz

## volk 1.2.2

=== debian/changelog ===
volk (1.2.2-2) unstable; urgency=medium

  * update to v1.2.2-11-g78c8bc4 (to follow gnuradio maint branch)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 19 Jun 2016 14:44:15 -0400

volk (1.2.2-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 08 Apr 2016 00:12:10 -0400

volk (1.2.1-2) unstable; urgency=medium

  * Upstream patches:
    Fix some CMake complaints
    The fix for compilation with cmake 3.5

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 23 Mar 2016 17:47:54 -0400

## volk 1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+add_definitions(-D_GLIBCXX_USE_CXX11_ABI=1)
 
 set(CMAKE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}) #allows this to be a sub-project
 set(CMAKE_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}) #allows this to be a sub-project
@@ -43,15 +44,15 @@
 message(STATUS "Build type set to ${CMAKE_BUILD_TYPE}.")
 
 set(VERSION_INFO_MAJOR_VERSION 1)
-set(VERSION_INFO_MINOR_VERSION 2)
-set(VERSION_INFO_MAINT_VERSION 1)
+set(VERSION_INFO_MINOR_VERSION 3)
+set(VERSION_INFO_MAINT_VERSION 0)
 include(VolkVersion) #setup version info
 
 
 ########################################################################
 # Environment setup
 ########################################################################
-IF(NOT DEFINED BOOST_ROOT)
+IF(NOT DEFINED BOOST_ROOT AND NOT DEFINED ENV{BOOST_ROOT})
     SET(BOOST_ROOT ${CMAKE_INSTALL_PREFIX})
 ENDIF()
 
@@ -215,6 +216,11 @@
 ########################################################################
 
 configure_file(
+  ${CMAKE_SOURCE_DIR}/cmake/Modules/VolkConfig.cmake.in
+  ${CMAKE_BINARY_DIR}/cmake/Modules/VolkConfig.cmake
+@ONLY)
+
+configure_file(
   ${CMAKE_SOURCE_DIR}/cmake/Modules/VolkConfigVersion.cmake.in
   ${CMAKE_BINARY_DIR}/cmake/Modules/VolkConfigVersion.cmake
 @ONLY)
@@ -230,7 +236,7 @@
 
 install(
     FILES
-    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/VolkConfig.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/cmake/Modules/VolkConfig.cmake
     ${CMAKE_CURRENT_BINARY_DIR}/cmake/Modules/VolkConfigVersion.cmake
     DESTINATION ${CMAKE_MODULES_DIR}/volk
     COMPONENT "volk_devel"
@@ -248,6 +254,31 @@
 message(STATUS "  Modify using: -DENABLE_TESTING=ON/OFF")
 
 ########################################################################
+# Option to enable post-build profiling using volk_profile, off by default
+########################################################################
+OPTION(ENABLE_PROFILING "Launch system profiler after build" OFF)
+if(ENABLE_PROFILING)
+  if(DEFINED VOLK_CONFIGPATH)
+    get_filename_component(VOLK_CONFIGPATH ${VOLK_CONFIGPATH} ABSOLUTE)
+    set(VOLK_CONFIGPATH "${VOLK_CONFIGPATH}/volk")
+    message(STATUS "System profiling is enabled, using path: ${VOLK_CONFIGPATH}")
+  elseif(DEFINED ENV{VOLK_CONFIGPATH})
+    set(VOLK_CONFIGPATH "$ENV{VOLK_CONFIGPATH}/volk")
+    message(STATUS "System profiling is enabled, using env path: $ENV{VOLK_CONFIGPATH}")
+  else()
+    message(STATUS "System profiling is enabled with default paths.")
+    if(DEFINED ENV{HOME})
+        set(VOLK_CONFIGPATH "$ENV{HOME}/.volk")
+    elseif(DEFINED ENV{APPDATA})
+        set(VOLK_CONFIGPATH "$ENV{APPDATA}/.volk")
+    endif()
+  endif()
+else()
+  message(STATUS "System profiling is disabled.")
+endif()
+message(STATUS "  Modify using: -DENABLE_PROFILING=ON/OFF")
+
+########################################################################
 # Setup the library
 ########################################################################
 add_subdirectory(lib)

=== debian/changelog ===
volk (1.3-3) unstable; urgency=medium

  * update to v1.3-23-g0109b2e
  * update debian/libvolk1-dev.abi.tar.gz.amd64
  * Add breaks/replaces gnuradio (<=3.7.2.1) (LP: #1614235)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 04 Feb 2018 13:12:21 -0500

volk (1.3-2) unstable; urgency=medium

  * update to v1.3-16-g28b03a9
    apps: fix profile update reading end of lines
    qa: lower tolerance for 32fc_mag to fix issue #96
  * include upstream master patch to sort input files

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 27 Aug 2017 13:44:55 -0400

volk (1.3-1) unstable; urgency=medium

  * New upstream release
  * The index_max kernels were named with the wrong output datatype. To
    fix this there are new kernels that return a 32u (int32_t) and the
    existing kernels had their signatures changed to return 16u (int16_t).
  * The output to stdout and stderr has been shuffled around. There is no
    longer a message that prints what VOLK machine is being used and the
    warning messages go to stderr rather than stdout.
  * The 32fc_index_max kernels previously were only accurate to the SSE
    register width (4 points). This was a pretty serious and long-lived
    bug that's been fixed and the QA updated appropriately.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 02 Jul 2016 16:30:47 -0400

=== debian/control ===
--- 
+++ 
@@ -14,12 +14,12 @@
                pkg-config,
                python,
                python-cheetah
-Standards-Version: 3.9.6
+Standards-Version: 4.1.3
 Homepage: http://libvolk.org
-Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-volk.git
-Vcs-Browser: http://anonscm.debian.org/cgit/users/bottoms/pkg-volk.git/
+Vcs-Browser: https://salsa.debian.org/bottoms/pkg-volk
+Vcs-Git: https://salsa.debian.org/bottoms/pkg-volk.git
 
-Package: libvolk1.1
+Package: libvolk1.3
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -36,9 +36,10 @@
 Package: libvolk1-dev
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk1.1 (=${binary:Version}), ${misc:Depends}
+Depends: libvolk1.3 (=${binary:Version}), ${misc:Depends}
 Breaks: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev
 Replaces: gnuradio-dev (<<3.7.8), libvolk-dev, libvolk1.0-dev
+Multi-Arch: same
 Description: vector optimized function headers
  Vector-Optimized Library of Kernels is designed to help
  applications work with the processor's SIMD instruction sets. These are
@@ -52,12 +53,12 @@
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libvolk1.1 (=${binary:Version}),
+Depends: libvolk1.3 (=${binary:Version}),
          ${misc:Depends},
          ${python:Depends},
          ${shlibs:Depends}
-Breaks: libvolk-bin, libvolk1.0-bin
-Replaces: libvolk-bin, libvolk1.0-bin
+Breaks: libvolk-bin, libvolk1.0-bin, gnuradio (<=3.7.2.1)
+Replaces: libvolk-bin, libvolk1.0-bin, gnuradio (<=3.7.2.1)
 Description: vector optimized runtime tools
  Vector-Optimized Library of Kernels is designed to help
  applications work with the processor's SIMD instruction sets. These are

=== debian/rules ===
--- 
+++ 
@@ -12,3 +12,6 @@
 
 override_dh_auto_test:
 	- dh_auto_test -- CTEST_TEST_TIMEOUT=60
+
+override_dh_acc:
+	- dh_acc

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
  http://libvolk.org/releases/volk-(\d\S*)\.tar\.gz
